    View Javadoc
    1   package org.apache.bcel.classfile;
    2
    3   /* ====================================================================
    4    * The Apache Software License, Version 1.1
    5    *
    6    * Copyright (c) 2001 The Apache Software Foundation.  All rights
    7    * reserved.
    8    *
    9    * Redistribution and use in source and binary forms, with or without
    10   * modification, are permitted provided that the following conditions
    11   * are met:
    12   *
    13   * 1. Redistributions of source code must retain the above copyright
    14   *    notice, this list of conditions and the following disclaimer.
    15   *
    16   * 2. Redistributions in binary form must reproduce the above copyright
    17   *    notice, this list of conditions and the following disclaimer in
    18   *    the documentation and/or other materials provided with the
    19   *    distribution.
    20   *
    21   * 3. The end-user documentation included with the redistribution,
    22   *    if any, must include the following acknowledgment:
    23   *       "This product includes software developed by the
    24   *        Apache Software Foundation (http://www.apache.org/)."
    25   *    Alternately, this acknowledgment may appear in the software itself,
    26   *    if and wherever such third-party acknowledgments normally appear.
    27   *
    28   * 4. The names "Apache" and "Apache Software Foundation" and
    29   *    "Apache BCEL" must not be used to endorse or promote products
    30   *    derived from this software without prior written permission. For
    31   *    written permission, please contact apache@apache.org.
    32   *
    33   * 5. Products derived from this software may not be called "Apache",
    34   *    "Apache BCEL", nor may "Apache" appear in their name, without
    35   *    prior written permission of the Apache Software Foundation.
    36   *
    37   * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
    38   * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
    39   * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
    40   * DISCLAIMED.  IN NO EVENT SHALL THE APACHE SOFTWARE FOUNDATION OR
    41   * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
    42   * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
    43   * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
    44   * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
    45   * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
    46   * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
    47   * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    48   * SUCH DAMAGE.
    49   * ====================================================================
    50   *
    51   * This software consists of voluntary contributions made by many
    52   * individuals on behalf of the Apache Software Foundation.  For more
    53   * information on the Apache Software Foundation, please see
    54   * <http://www.apache.org/>;.
    55   */
    56
    57  import  org.apache.bcel.Constants;
    58  import  java.io.*;
    59
    60  /***
    61   * This class is derived from <em>Attribute</em> and denotes that this class
    62   * is an Inner class of another.
    63   * to the source file of this class.
    64   * It is instantiated from the <em>Attribute.readAttribute()</em> method.
    65   *
    66   * @version $Id: InnerClasses.java,v 1.2 2002/03/11 16:16:35 mdahm Exp $
    67   * @author  <A HREF="mailto:markus.dahm@berlin.de">M. Dahm</A>
    68   * @see     Attribute
    69   */
    70  public final class InnerClasses extends Attribute {
    71    private InnerClass[] inner_classes;
    72    private int          number_of_classes;
    73
    74    /***
    75     * Initialize from another object. Note that both objects use the same
    76     * references (shallow copy). Use clone() for a physical copy.
    77     */
    78    public InnerClasses(InnerClasses c) {
    79      this(c.getNameIndex(), c.getLength(), c.getInnerClasses(),
    80  	 c.getConstantPool());
    81    }
    82
    83    /***
    84     * @param name_index Index in constant pool to CONSTANT_Utf8
    85     * @param length Content length in bytes
    86     * @param inner_classes array of inner classes attributes
    87     * @param constant_pool Array of constants
    88     * @param sourcefile_index Index in constant pool to CONSTANT_Utf8
    89     */
    90    public InnerClasses(int name_index, int length,
    91  		      InnerClass[] inner_classes,
    92  		      ConstantPool constant_pool)
    93    {
    94      super(Constants.ATTR_INNER_CLASSES, name_index, length, constant_pool);
    95      setInnerClasses(inner_classes);
    96    }
    97
    98    /***
    99     * Construct object from file stream.
    100    *
    101    * @param name_index Index in constant pool to CONSTANT_Utf8
    102    * @param length Content length in bytes
    103    * @param file Input stream
    104    * @param constant_pool Array of constants
    105    * @throws IOException
    106    */
    107   InnerClasses(int name_index, int length, DataInputStream file,
    108 	       ConstantPool constant_pool) throws IOException
    109   {
    110     this(name_index, length, (InnerClass[])null, constant_pool);
    111
    112     number_of_classes = file.readUnsignedShort();
    113     inner_classes = new InnerClass[number_of_classes];
    114
    115     for(int i=0; i < number_of_classes; i++)
    116       inner_classes[i] = new InnerClass(file);
    117   }
    118   /***
    119    * Called by objects that are traversing the nodes of the tree implicitely
    120    * defined by the contents of a Java class. I.e., the hierarchy of methods,
    121    * fields, attributes, etc. spawns a tree of objects.
    122    *
    123    * @param v Visitor object
    124    */
    125   public void accept(Visitor v) {
    126     v.visitInnerClasses(this);
    127   }
    128   /***
    129    * Dump source file attribute to file stream in binary format.
    130    *
    131    * @param file Output file stream
    132    * @throws IOException
    133    */
    134   public final void dump(DataOutputStream file) throws IOException
    135   {
    136     super.dump(file);
    137     file.writeShort(number_of_classes);
    138
    139     for(int i=0; i < number_of_classes; i++)
    140       inner_classes[i].dump(file);
    141   }
    142
    143   /***
    144    * @return array of inner class "records"
    145    */
    146   public final InnerClass[] getInnerClasses() { return inner_classes; }
    147
    148   /***
    149    * @param inner_classes.
    150    */
    151   public final void setInnerClasses(InnerClass[] inner_classes) {
    152     this.inner_classes = inner_classes;
    153     number_of_classes = (inner_classes == null)? 0 : inner_classes.length;
    154   }
    155
    156   /***
    157    * @return String representation.
    158    */
    159   public final String toString() {
    160     StringBuffer buf = new StringBuffer();
    161
    162     for(int i=0; i < number_of_classes; i++)
    163       buf.append(inner_classes[i].toString(constant_pool) + "\n");
    164
    165     return buf.toString();
    166   }
    167
    168   /***
    169    * @return deep copy of this attribute
    170    */
    171   public Attribute copy(ConstantPool constant_pool) {
    172     InnerClasses c = (InnerClasses)clone();
    173
    174     c.inner_classes = new InnerClass[number_of_classes];
    175     for(int i=0; i < number_of_classes; i++)
    176       c.inner_classes[i] = inner_classes[i].copy();
    177
    178     c.constant_pool = constant_pool;
    179     return c;
    180   }
    181 }

This page was automatically generated by Maven